=== debian/changelog ===
ros-melodic-libfranka (0.8.0-1stretch) stretch; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Franka Emika GmbH <support@franka.de>  Tue, 30 Jun 2020 09:14:26 -0000
