=== debian/changelog ===
ros-melodic-libfranka (0.9.0-1bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Franka Emika GmbH <support@franka.de>  Mon, 28 Mar 2022 09:13:10 -0000
